#include <stdio.h>
#include <unistd.h>
#include <pthread.h>
#include<stdlib.h>
#define N 4
int checkingAccount;
int savingAccount;

pthread_mutex_t mutex;
pthread_t mThread[N];
 
//transfer money from checking to saving account
void *transfer_money_from_checking_to_saving(void *data)
{      
       int money=(int)data;
        

       	pthread_mutex_lock(&mutex);
        
        if(money >checkingAccount) 
        {
            printf("can't make this transfer, too less money on the checking account\n"); 
           return NULL;
         }     	  
        checkingAccount-=money;
        savingAccount+=money;

         pthread_mutex_unlock(&mutex);

         printf("transfer_money_from_checking_to_saving thread finished\n");
	return NULL;
  }


//transfer money from saving to checking account
void *transfer_money_from_saving_to_checking(void *data)
{      
       int money=(int)data;
        

       	pthread_mutex_lock(&mutex);
        
        if(money >savingAccount) 
        {
            printf("can't make this transfer, too less money on the saving account\n"); 
           return NULL;
         }     	  
        checkingAccount+=money;
        savingAccount-=money;

         pthread_mutex_unlock(&mutex);

         printf("transfer_money_from_saving_to_checking thread finished\n");
	return NULL;
  }


void* deposit_to_checking(void * data)
{

      int money=(int)data;
        

       pthread_mutex_lock(&mutex);

        checkingAccount+=money;

     
       pthread_mutex_unlock(&mutex);

       printf("deposit_to_checking thread finished\n");

      	return NULL;

}


void* deposit_to_saving(void * data)
{

      int money=(int)data;
        

       pthread_mutex_lock(&mutex);

        savingAccount+=money;

     
       pthread_mutex_unlock(&mutex);

       printf("deposit_to_saving thread finished\n");

       	return NULL;

}



int main(int argc, char *argv[])
{
	int rc,i;
	/* Initialize mutex and condition variable objects */
 
        pthread_mutex_init(&mutex, NULL);

        int money=10000;

        int transfer=100;

        	/* create thread */
        rc = pthread_create(&mThread[0], NULL,deposit_to_checking , (void *)money );
        if (rc) {
		printf("create thread failed. error code = %d\n", rc);
	}

                 	/* create thread */
        rc = pthread_create(&mThread[1], NULL,deposit_to_saving , (void *)money );
        if (rc) {
		printf("create thread failed. error code = %d\n", rc);
	}

         
         
	/* create thread */
        rc = pthread_create(&mThread[2], NULL, transfer_money_from_checking_to_saving, (void*) transfer);
        if (rc) {
		printf("create thread failed. error code = %d\n", rc);
	}


        	/* create thread */
        rc = pthread_create(&mThread[3], NULL, transfer_money_from_saving_to_checking, (void*) transfer);
        if (rc) {
		printf("create thread failed. error code = %d\n", rc);
	}

       for(i=0;i<N;i++)
   	 pthread_join(mThread[i], NULL);


         printf("checkingAccount=%d, savingAccount=%d\n", checkingAccount, savingAccount);         

          printf("main thread finished\n");
	return 0;
}
