#include "lk_helper.h"
#include "utility.h"
#include<stdio.h> // for "FILE"


Int numLoads = 0;
Int numStores = 0;

Int lastThread = -1;

REGPARM(3)
void DJ_record_stmt_info(Char *file, Char *function, Int line)
{

/*
         // see if the startRecordingStmts file is present
         FILE *tempFile = fopen("#vg_start_record_stmts.txt", "r");
         Bool startRecordStmtsFileExists = False;
         if(tempFile != NULL)
         {
            startRecordStmtsFileExists = True;
            fclose(tempFile);
         }

   if(startRecordStmtsFileExists == True)
   {
      //FILE *filePointer = fopen("#vg_stmt_trace.txt", "a");
      //fprintf(filePointer, "%s/%s/%d\n", file, function, line);
      //fclose(filePointer);
      //VG_(printf)("%s/%s/%d\n", file, function, line);
      
      /*
            Int junk = VG_(open)("#vg_stmt_trace.txt", VKI_O_CREAT|VKI_O_APPEND|VKI_O_WRONLY,
                                       VKI_S_IRUSR|VKI_S_IWUSR);
            Char buffer[2048];
            VG_(sprintf)(buffer, "%s/%s/%d\n", file, function, line);
            VG_(write)(junk, buffer, VG_(strlen)(buffer));
            VG_(close)(junk);
      *
            
   }
   */
}


// Hashtables for suppressed locations (memory addresses, arch regs, temp regs)
VgHashTable suppressedMem;
VgHashTable suppressedArch;
VgHashTable suppressedArchS;
VgHashTable suppressedTemp;

Bool storeIsSuppressed = False;
UInt loadDestReg = 0;
Addr loadCurrX86 = 0x0;

void markSuppressed(VgHashTable table, UInt value)
{
   SuppressLocation *node;
   VgHashNode ** dummy;
   
   node = (SuppressLocation *) VG_(HT_get_node) (table, value, &dummy);
   if(node == NULL)
   {
      node = (SuppressLocation *)(VG_(calloc)(1, sizeof(SuppressLocation)));
      node->location = value;
      node->isSuppressed = True;
      VG_(HT_add_node)(table, (VgHashNode*)(node));
   }
   else
   {
      node->isSuppressed = True;
   }
}

void markNotSuppressed(VgHashTable table, UInt value)
{
   SuppressLocation *node;
   VgHashNode ** dummy;
   
   node = (SuppressLocation *) VG_(HT_get_node) (table, value, &dummy);
   if(node == NULL)
   {
      node = (SuppressLocation *)(VG_(calloc)(1, sizeof(SuppressLocation)));
      node->location = value;
      node->isSuppressed = False;
      VG_(HT_add_node)(table, (VgHashNode*)(node));
   }
   else
   {
      node->isSuppressed = False;
   }
}

REGPARM(3)
void DJ_transfer_mark_arch_temp_to_temp(UInt archRegSource1, UInt tempRegSource2, UInt tempRegDest)
{
   VgHashNode ** dummy;
   SuppressLocation *node;
   Bool eitherSourceIsSuppressed = False;
   node = VG_(HT_get_node) (suppressedArch, archRegSource1, &dummy);
   if(node != NULL && node->isSuppressed == True)
   {
      eitherSourceIsSuppressed = True;
   }
   node = VG_(HT_get_node) (suppressedTemp, tempRegSource2, &dummy);
   if(node != NULL && node->isSuppressed == True)
   {
      eitherSourceIsSuppressed = True;
   }
   
   if(eitherSourceIsSuppressed)
   {
      markSuppressed(suppressedTemp, tempRegDest);
   }
   else
   {
      markNotSuppressed(suppressedTemp, tempRegDest);
   }
}

REGPARM(3)
void DJ_transfer_mark_temp_temp_to_temp(UInt tempRegSource1, UInt tempRegSource2, UInt tempRegDest)
{
   VgHashNode ** dummy;
   SuppressLocation *node;
   Bool eitherSourceIsSuppressed = False;
   node = VG_(HT_get_node) (suppressedTemp, tempRegSource1, &dummy);
   if(node != NULL && node->isSuppressed == True)
   {
      eitherSourceIsSuppressed = True;
   }
   node = VG_(HT_get_node) (suppressedTemp, tempRegSource2, &dummy);
   if(node != NULL && node->isSuppressed == True)
   {
      eitherSourceIsSuppressed = True;
   }
   
   if(eitherSourceIsSuppressed)
   {
      markSuppressed(suppressedTemp, tempRegDest);
   }
   else
   {
      markNotSuppressed(suppressedTemp, tempRegDest);
   }
}

REGPARM(2)
void DJ_transfer_mark_temp_to_temp(UInt tempRegSource, UInt tempRegDest)
{
   VgHashNode ** dummy;
   SuppressLocation *node;
   node = VG_(HT_get_node) (suppressedTemp, tempRegSource, &dummy);
   if(node != NULL && node->isSuppressed == True)
   {
      markSuppressed(suppressedTemp, tempRegDest);
   }
   else
   {
      markNotSuppressed(suppressedTemp, tempRegDest);
   }
}

REGPARM(2)
void DJ_transfer_mark_temp_to_arch(UInt tempReg, UInt archReg)
{
   VgHashNode ** dummy;
   SuppressLocation *node;
   node = VG_(HT_get_node) (suppressedTemp, tempReg, &dummy);
   if(node != NULL && node->isSuppressed == True)
   {
      markSuppressed(suppressedArch, archReg);
   }
   else
   {
      markNotSuppressed(suppressedArch, archReg);
   }
}

REGPARM(2)
void DJ_transfer_mark_arch_to_temp(UInt archReg, UInt tempReg)
{
   VgHashNode ** dummy;
   SuppressLocation *node;
   node = VG_(HT_get_node) (suppressedArch, archReg, &dummy);
   if(node != NULL && node->isSuppressed == True)
   {
      markSuppressed(suppressedTemp, tempReg);
   }
   else
   {
      markNotSuppressed(suppressedTemp, tempReg);
   }
}

REGPARM(2)
void DJ_transfer_mark_temp_to_archS(UInt tempReg, UInt archRegS)
{
   VgHashNode ** dummy;
   SuppressLocation *node;
   node = VG_(HT_get_node) (suppressedTemp, tempReg, &dummy);
   if(node != NULL && node->isSuppressed == True)
   {
      markSuppressed(suppressedArchS, archRegS);
   }
   else
   {
      markNotSuppressed(suppressedArchS, archRegS);
   }
}

REGPARM(2)
void DJ_transfer_mark_archS_to_temp(UInt archRegS, UInt tempReg)
{
   VgHashNode ** dummy;
   SuppressLocation *node;
   node = VG_(HT_get_node) (suppressedArchS, archRegS, &dummy);
   if(node != NULL && node->isSuppressed == True)
   {
      markSuppressed(suppressedTemp, tempReg);
   }
   else
   {
      markNotSuppressed(suppressedTemp, tempReg);
   }
}

REGPARM(1)
void DJ_mark_not_suppressed_temp(UInt tempReg)
{
   markNotSuppressed(suppressedTemp, tempReg);
}

REGPARM(2)
void DJ_set_dest_reg_for_load(UInt tempReg, Addr currX86Addr)
{
   loadDestReg = tempReg;
   loadCurrX86 = currX86Addr;
}

REGPARM(2)
void DJ_set_flag_for_store_if_suppressed(UInt tempRegSource, UInt tempRegDest)
{
   VgHashNode ** dummy;
   SuppressLocation *node;
   node = VG_(HT_get_node) (suppressedTemp, tempRegSource, &dummy);
   if(node != NULL && node->isSuppressed == True)
   {
      storeIsSuppressed = True;
   }
   node = VG_(HT_get_node) (suppressedTemp, tempRegDest, &dummy);
   if(node != NULL && node->isSuppressed == True)
   {
      storeIsSuppressed = True;
   }
}

Bool recordLS = False;



REGPARM(2)
UInt DJ_handle_load_to_possibly_suppress(UInt sourceTempReg, Addr sourceAddr)
{
   Int i;
   Bool isSuppressed = False;
   VgHashNode ** dummy;
   SuppressLocation *node;
   node = VG_(HT_get_node) (suppressedTemp, sourceTempReg, &dummy);
   if(node != NULL && node->isSuppressed == True)
   {
      isSuppressed = True;
   }
   node = VG_(HT_get_node) (suppressedMem, sourceAddr, &dummy);
   if(node != NULL && node->isSuppressed == True)
   {
      isSuppressed = True;
   }
   
   if(isSuppressed)
   {  
      // mark the destination tempReg as suppressed
      markSuppressed(suppressedTemp, loadDestReg);

      loadDestReg = 0;
      loadCurrX86 = 0x0;
      
      // ensure that we load from the scratch location
      return (UInt)(scratchLocation);
   }
   else
   {
      // output information about the load that's taking place
      x86InstrStruct *node2 = getX86InstrInfo(loadCurrX86);
      myAssert(node2 != NULL, "when handling loads, could not get x86 instr info struct!");
      
      //if((VG_(strcmp)(node2->file, "mod_log_config.c") == 0 && VG_(strcmp)(node2->function, "flush_log") == 0) ||
      //    sourceAddr == 0x80F163C || sourceAddr == 0x80F1638)
      //if(VG_(strcmp)(node2->file, "http.c") == 0 && node2->line == 417)
      //{
      //VG_(printf)("L%x:%x#%dT%d\n", sourceAddr, node2->x86Addr, node2->currentInstance, VG_(get_current_or_recent_tid)());
      //}
      
      
      //if(numLoads % 10000 == 0)
      //{
      //   printf("%d loads and %d stores\n", numLoads, numStores);
      //}
      
      
      numLoads++;
      //threads[VG_(get_current_or_recent_tid)()] = 1;
      
      if(VG_(get_current_or_recent_tid)() != lastThread)
      {
         lastThread = VG_(get_current_or_recent_tid)();
         printf("Thread: %d\n", VG_(get_current_or_recent_tid)());
         
         FILE *fp = fopen("threads.txt", "a");
         fprintf(fp, "Thread: %d\n", VG_(get_current_or_recent_tid)());
         fclose(fp);
         
      }
      
      //if(VG_(strcmp)(node2->file, "???") != 0)
      //if(recordLS == True)
      {
      //FILE *fp = fopen("rats.txt", "a");
      //fprintf(fp, "!! L 0x%x: %s@%d %s 0x%x#%d \n", sourceAddr, node2->file, node2->line, node2->function, node2->x86Addr, node2->currentInstance);
      //fclose(fp);
      }
      
      /*
      if(VG_(strcmp)(node2->file, "man.c") == 0 || VG_(strcmp)(node2->file, "manfile.c") == 0)
      {
         VG_(printf)("!! L 0x%x: %s@%d %s 0x%x#%d\n", sourceAddr, node2->file, node2->line, node2->function, node2->x86Addr, node2->currentInstance);
      }
      */
   
      // mark the destination tempReg as not suppressed
      markNotSuppressed(suppressedTemp, loadDestReg);
      
      loadDestReg = 0;
      loadCurrX86 = 0x0;
      
      // ensure that we load from the original location
      return sourceAddr;
   }
}

REGPARM(2)
UInt DJ_handle_initial_suppression_point(Addr currX86Addr, Addr addressStoredTo)
{
    x86InstrStruct *node = getX86InstrInfo(currX86Addr);
    myAssert(node != NULL, "when handling initial suppression point, could not get x86 instr info struct!");
    
    // see if any specified initial suppression points are for the current instruction instance
    Bool suppressHere = False;
    suppressPointNode *curr = suppressPointList;
    while(curr != NULL)
    {
       //printf("*** 0x%x, %d\n", curr->instrAddr,curr->instanceNum);
       if(curr->instrAddr == currX86Addr && curr->instanceNum == node->currentInstance)
       {
          suppressHere = True;
          break;
       }
       curr = curr->next;
    }
    
    if(suppressHere)
    {
       // this is an initial suppression point!
       
       // mark the address stored to as a suppressed address
       markSuppressed(suppressedMem, (UInt)addressStoredTo);

       // reset the flag (just in case) so it's ready for the next store
       storeIsSuppressed = False;
       
       // return the scratch address space so that the store is performed to the scratch space
       return (UInt)(scratchLocation);
    }
    else
    {
       // this is not an initial suppression point
       
       if(storeIsSuppressed)
       {
          // reset the flag so it's ready for the next store
          storeIsSuppressed = False;
          
          // even though it's not an initial suppression point, this store is still suppressed.
          markSuppressed(suppressedMem, (UInt)addressStoredTo);
          
          // return the scratch address
          return (UInt)(scratchLocation);
       }
       else
       {
          // this store is a regular non-suppressed store
          
          // output information about the store that's taking place
          //if((VG_(strcmp)(node->file, "mod_log_config.c") == 0 && VG_(strcmp)(node->function, "flush_log") == 0) ||
          //   addressStoredTo == 0x80F163C || addressStoredTo == 0x80F1638)
          //if(VG_(strcmp)(node->file, "ftpsearch.c") == 0 && node->line == 320)
          //if(addressStoredTo == 0x3A9FE5AC)
          //{
          //VG_(printf)("S%x:%x#%dT%d)\n", addressStoredTo, currX86Addr, node->currentInstance, VG_(get_current_or_recent_tid)());
          //}
          
          
          numStores++;
          //threads[VG_(get_current_or_recent_tid)()] = 1;
          if(VG_(get_current_or_recent_tid)() != lastThread)
          {
             lastThread = VG_(get_current_or_recent_tid)();
             printf("Thread: %d\n", VG_(get_current_or_recent_tid)());
             
             FILE *fp = fopen("threads.txt", "a");
             fprintf(fp, "Thread: %d\n", VG_(get_current_or_recent_tid)());
             fclose(fp);
          }
          
          if(currX86Addr == 0x80A0275 && node->currentInstance == 0) recordLS = True;
          
          //if(VG_(strcmp)(node->file, "???") != 0)
          //if(recordLS == True)
          //if(addressStoredTo == 0x8100000)
          {
          //FILE *fp = fopen("rats.txt", "a");
          //fprintf(fp, "!! S 0x%x: %s@%d, %s 0x%x#%d \n", addressStoredTo, node->file, node->line, node->function, currX86Addr, node->currentInstance);
          //fclose(fp);
          }
          
          /*
          if(VG_(strcmp)(node->file, "man.c") == 0 || VG_(strcmp)(node->file, "manfile.c") == 0)
          {
             VG_(printf)("!! S 0x%x: %s@%d, %s 0x%x#%d\n", addressStoredTo, node->file, node->line, node->function, currX86Addr, node->currentInstance);
          }
          */
          
          // mark the defined location as NOT suppressed
          markNotSuppressed(suppressedMem, (UInt)addressStoredTo);
          
          // return the original address stored to
          return (UInt)(addressStoredTo);
       }
    }
}

REGPARM(3)
void XZ_HELPER_debug_load_value(Addr currX86Addr, Addr addressLoadedFrom, UInt value)
{
    //VG_(printf) ("[%x]=%x\n", a, value);
    x86InstrStruct *node = getX86InstrInfo(currX86Addr);
    myAssert(node != NULL, "when loading, could not get x86 instr info struct!");
    
    VG_(printf)("!! L 0x%x: %s@%d %s 0x%x#%d\n", addressLoadedFrom, node->file, node->line, node->function, currX86Addr, node->currentInstance);
}

REGPARM(3)
void XZ_HELPER_debug_store_value(Addr currX86Addr, UInt value, Addr addressStoredTo)
{
    //VG_(printf) ("STORE @ %x put [%x]= %x\n", instr, a,value);
    x86InstrStruct *node = getX86InstrInfo(currX86Addr);
    myAssert(node != NULL, "when storing, could not get x86 instr info struct!");
    
    VG_(printf)("!! S 0x%x: %s@%d, %s 0x%x#%d\n", addressStoredTo, node->file, node->line, node->function, currX86Addr, node->currentInstance);
}

REGPARM(1)
void DJ_print_value(UInt value)
{
   // VG_(printf)("[0x%x]\n", value);
   
   //if(recordLS == True)
   //{
   FILE *fp = fopen("rats.txt", "a");
   fprintf(fp, "[0x%x]\n", value);
   fclose(fp);
   //}
}

REGPARM(2)
void DJ_debug_trace(Addr currX86Addr, UInt opcode)
{
   VG_(printf)("*** 0x%x: %d\n", currX86Addr, opcode);
}











XZ_shadow_reg sh_regs[8];
static Int timestamp=0;

// DENNIS added this separate-chained hashtable to store the trace entries built.  Auto-zeroed.
static stringListNode *traceEntriesSoFar[NUM_TRACE_ENTRIES_TABLE_SIZE];

REGPARM(0)
void DJ_junk()
{
   ThreadId tid = VG_(get_current_tid)();
   Addr eip = VG_(get_EIP)(tid);
   
   // note: DENNIS verified that "eip" refers to the address of the current x86 instruction
   // being executed
   
   VG_(describe_addr)(tid, eip);
}

REGPARM(1)
void DJ_update_last_instr_main_file(instr_info * ii)
{
   lastInstrExecutedFromMainSourceFile = ii;
}

/***********************************************************************
* Dennis functions to maintain call stack to be used for stack addresses
***********************************************************************/

void writeInfoToStackLogFile(Char *buf)
{
   if(valgrindMode == MODE_FORCE_MAPPING)
   {
      return;
   }
   
   Int pid=VG_(gettid)();
   Char buffy[128];
   VG_(sprintf)(buffy,"TRACE.%d.stackLog.txt",pid);
   FILE *filePointer = fopen(buffy, "a");
   
   fprintf(filePointer, "%s\n", buf);
      
   fclose(filePointer);
}

stackNode *stack = NULL;
Char dummyWord[6];

void pushToStack(fnCC *functionObject, UInt baseAddr)
{
    Char buffy[128];
    
	// output info to file logging stack pushes/pops
    VG_(sprintf)(buffy,"call %s#%u", functionObject->fn, functionObject->nextInstanceNumToUse);    
    writeInfoToStackLogFile(buffy);
    
    // create new node	
	stackNode *newNode = (stackNode *)(VG_(malloc)(sizeof(stackNode)));
	newNode->func = functionObject->fn;
	newNode->instNum = functionObject->nextInstanceNumToUse;
	(functionObject->nextInstanceNumToUse)++;
	newNode->baseAddr = baseAddr;
	newNode->next = NULL;
   
	// empty stack case
	if(stack == NULL)
	{
	    // special case: ensure there's a dummy node at the bottom of the stack with the MAXIMUM base address
	    // so that any stack address will be within SOME stack frame.  Due to some library funcs not processed since
	    // their names are "???", then without the dummy node, some addresses would be outside any known stack frames.
	    stackNode *dummyNode = (stackNode *)(VG_(malloc)(sizeof(stackNode)));
	    VG_(sprintf)(dummyWord, "DUMMY");
	    dummyNode->func = dummyWord;
	    dummyNode->instNum = 0;
	    dummyNode->baseAddr = VG_(clstk_end);
	    newNode->next = dummyNode;
	    
		stack = newNode;
		return;
	}
	
	if(stack->baseAddr < baseAddr)
	{
	   VG_(printf)("Warning: why is new base address to add actually GREATER than the previous stack frame's base?!?!\n");
	}
	
	// regular push onto front of stack
	newNode->next = stack;
	stack = newNode;
	return;
}

void popFromStack(fnCC *functionObject)
{
    Char buffy[128];
    
	if(stack == NULL) VG_(printf)("Error: trying to pop from empty stack?!?!");

    // need special check for "read"/"write"/"open": if the top of the call stack doesn't match the function
    // we're returning from, but the top of the call stack is "read"/"write"/etc, then pop it, and
    // NOW the top of the call stack should match.  This was needed since sometimes "read"/"write"/etc
    // don't seem to end in "ret" instruction, so we sometimes miss those exits.	
	if(VG_(strcmp)(stack->func,functionObject->fn) == 0)
	{
	   UInt instNum = stack->instNum;
	   stackNode *temp = stack;
	   stack = stack->next;
	   VG_(free)(temp);
	   
	   // output info to file logging stack pushes/pops
       VG_(sprintf)(buffy,"ret %s#%u", functionObject->fn, instNum);    
       writeInfoToStackLogFile(buffy);
	}
	// below cases: top of stack does not match the thing to pop off
	else if(VG_(strcmp)(stack->func, "write") == 0 ||
	        VG_(strcmp)(stack->func, "read") == 0 ||
	        VG_(strcmp)(stack->func, "open") == 0)
	{
	   UInt instNum = stack->instNum;
	   stackNode *temp = stack;
	   stack = stack->next;
	   VG_(free)(temp);
	   popFromStack(functionObject);
	}
}

void printStack()
{
	VG_(printf)("Stack: ");
	if(stack == NULL)
	{
		VG_(printf)("[EMPTY STACK]\n");
		return;
	}
	stackNode *curr = stack;
	VG_(printf)("[%s#%u: %d]", curr->func, curr->instNum, curr->baseAddr);
	curr = curr->next;
	while(curr != NULL)
	{
		VG_(printf)(", [%s#%u: %d]", curr->func, curr->instNum, curr->baseAddr);
		curr = curr->next;
	}
	VG_(printf)("\n");
}

REGPARM(1)
void DJ_got_func_ret(fnCC *functionObject)
{
   if(VG_(strcmp)(functionObject->fn, "???") != 0)
   {
      //VG_(printf)("Got return: %s\n", functionObject->fn);
      
      popFromStack(functionObject);      
      //printStack();
   }
}

REGPARM(2)
void DJ_got_func_entry(fnCC *functionObject, UInt baseAddr)
{
   if(VG_(strcmp)(functionObject->fn, "???") != 0)
   {
      //VG_(printf)("Got entry:  %s\n", functionObject->fn);

      pushToStack(functionObject, baseAddr);
      //printStack();
   }
}

/***********************************************************************
* End dennis functions to maintain call stack to be used for stack addresses
***********************************************************************/

// Record the current stmt as having been exercised during execution (for recording stmt coverage)
REGPARM(1)
void DJ_HELPER_record_stmt(Int stmt)
{
   insert_stmt(stmt);
}


REGPARM(1)
Int XZ_HELPER_get_inst (instr_info * ii)
{
     //VG_(printf) ("GET_INST =%d\n",ii->cur_inst);
     return ii->cur_inst;
}

REGPARM(1)
void XZ_HELPER_increment_inst (x86InstrStruct * node)
{
     (node->currentInstance)++;
     
     /*
     Char buffy[128];
     
     ii->cur_inst++;
     
     // every binary instruction would call this function, so if the current instruction is
     // from the main source code file, then save this as the last instruction executed so far
     if(VG_(strcmp)(ii->file, VG_(getClientProgramName)()) == 0)
     {
        // assume the current instr is from the main source code file!
        lastInstrExecutedFromMainSourceFile = ii;
        lastInstrInstanceExecutedFromMainSourceFile = ii->cur_inst - 1;
        if(ii->orig_addr < smallestInstrAddrExecutedFromMainSourceFile)
        {
        	smallestInstrAddrExecutedFromMainSourceFile = ii->orig_addr;
        }
        if(ii->orig_addr > largestInstrAddrExecutedFromMainSourceFile)
        {
        	largestInstrAddrExecutedFromMainSourceFile = ii->orig_addr;
        }
        
        // write the current instruction to the trace log file so that later we can tell how
        // to adjust the stack that is maintained while searching for IVMPs
        VG_(sprintf)(buffy,"ex %x@%d", ii->orig_addr, ii->line);    
        writeInfoToStackLogFile(buffy);
     }
     */
}

// for all mappings to force that are at the specified x86 instruction, increment the
// current instance number of those mappings to indicate which instance we're currently
// on (used later to determine whether to force the values at the current instance or not)
REGPARM(3)
void DJ_HELPER_increment_force_inst(Addr x86_addr, mapping_force *mappings [], Int numMappings)
{
   Int i, j;

   for(i = 0; i < numMappings; i++)
   {
      if(mappings[i]->instructionAddr == x86_addr)
      {
         // clear the instrumentation flags set by the current mapping, so that if the associated
         // instruction has to be instrumented again, the flags are re-initialized already
         for(j = 0; j < mappings[i]->numUses; j++)
         {
            (mappings[i]->usedLocationWasReturned)[j] = False;
         }
      
         // increment the current instance
         (mappings[i]->currInstance)++;
      }
   }
}

// if we get to the instance of the first instance-to-force, then set a flag indicating so!
REGPARM(3)
void DJ_HELPER_set_flag_at_forced_inst(Addr x86_addr, mapping_force *mappings [], Int numMappings)
{
   Int i, j;

   for(i = 0; i < numMappings; i++)
   {
      if(mappings[i]->instructionAddr == x86_addr)
      {
         if(mappings[i]->currInstance == mappings[i]->instanceNum)
         {
            // we got to the instance to force! Set the flag!
            //VG_(printf)("Got to the appropriate instance!!!!!!!!!!!!!!!\n");
            gotToForcedInstance = True;
         }
         else
         {
            // not the correct instance to set the flag
            //VG_(printf)("not correct instance %d %d\n",mappings[i]->currInstance,mappings[i]->instanceNum);
         }
      }
   }
}





static Char **traceEntryArray = NULL;
int numTraceEntries = 0;
int traceEntryArraySize = 0;
#define TRACE_ENTRY_ARRAY_RESIZE_AMOUNT 1024

void write_trace_optimized(Char *file)
{
   Int i;
   Int fd;
   
   fd = VG_(open)(file, VKI_O_CREAT|VKI_O_TRUNC|VKI_O_WRONLY, VKI_S_IRUSR|VKI_S_IWUSR);
   
   for(i = 0; i < numTraceEntries; i++)
   {
      Char *entry = traceEntryArray[i];
      VG_(write)(fd, (void *)(entry), VG_(strlen)(entry));
      VG_(free)(entry);
   }
   
   VG_(close)(fd);
}

static UInt hash(Char *s, UInt table_size)
{
   const int hash_constant = 256;
   int hash_value = 0;
   for ( ; *s; s++)
      hash_value = (hash_constant * hash_value + *s) % table_size;
   return hash_value;
}

// DENNIS helper function for write_trace
void insertTraceEntryInTable(Char *str)
{
   Int hashIndex;
   stringListNode *currNode;

   hashIndex = hash(str, NUM_TRACE_ENTRIES_TABLE_SIZE);
   
   currNode = traceEntriesSoFar[hashIndex];
   while(currNode != NULL && VG_(strcmp)(str, currNode->val) != 0)
   {
      currNode = currNode->next;
   }
   // at this point, either currNode is NULL (meaning the str is not yet in the hashtable), or else
   // currNode points to an existing node already in the table (in which case we don't need to add anything)
   if(currNode == NULL)
   {
      // need to add a new node to the hashtable (add it to the FRONT of the linked list at this hashtable position)
      
      // make a new node
      // (using calloc(numElements, elementSize) zeroes the allocated space)
      stringListNode *newNode = VG_(calloc)(1, sizeof(stringListNode));
      newNode->val = str;
      newNode->next = traceEntriesSoFar[hashIndex];
      
      // link the new node into the hashtable
      traceEntriesSoFar[hashIndex] = newNode;
   }
}

// DENNIS another helper function for write_trace
Bool isTraceEntryInTable(Char *str)
{
   Int hashIndex;
   stringListNode *currNode;

   hashIndex = hash(str, NUM_TRACE_ENTRIES_TABLE_SIZE);

   currNode = traceEntriesSoFar[hashIndex];

   while(currNode != NULL && VG_(strcmp)(str, currNode->val) != 0)
   {
      currNode = currNode->next;
   }
   // at this point, either currNode is NULL (meaning the str is not in the hashtable), or else
   // currNode points to an existing node for that str already in the table
   if(currNode != NULL)
   {
      // it's there!
      return True;
   }
   else
   {
      // not there
      return False;
   }
}

void insertTraceEntry(Char *traceEntry)
{
   Char *entryCopy = (Char **)(VG_(malloc)((VG_(strlen)(traceEntry) * sizeof(Char)) + 2));
   VG_(strcpy)(entryCopy, traceEntry);
   VG_(strcat)(entryCopy, "\n");

   if(numTraceEntries >= traceEntryArraySize)
   {
      traceEntryArraySize += TRACE_ENTRY_ARRAY_RESIZE_AMOUNT;
      if(traceEntryArray)
      {
         traceEntryArray = VG_(realloc)(traceEntryArray, traceEntryArraySize*(sizeof(Char *)));
      }
      else
      {
         traceEntryArray = VG_(calloc)(traceEntryArraySize, sizeof(Char *));
      }
   }
   
   // only insert the trace entry if it's not already there (multiple instances only get put there once)
   if(isTraceEntryInTable(entryCopy) == False)
   {
      insertTraceEntryInTable(entryCopy);
      
      traceEntryArray[numTraceEntries] = entryCopy;
      numTraceEntries++;
   }
   else
   {
      // it's already there, so don't need to insert again
      VG_(free)(entryCopy);
   }
}

// build the current trace entry and output it if necessary
Char lastJumpEntryPrefix[128];
Char lastJumpEntryFullShorter[1024];
REGPARM(1)
void DJ_processTraceEntry(instr_info *ii)
{
   Int j;
   val_stream *vs;
   Char traceEntryPrefix[128];
   Char traceEntryPrefixShorter[128];
   Char traceEntrySuffix[1024];
   Char traceEntry[1152];
   Char traceEntryToCompareToKeep[1024];
   Char buf[1024];
   instr_info *otherII;
   Int otherInstanceNum;
   
   VG_(printf)("Warning: need to update this function to handle floating-pt, addresses as necessary!!!");

   if(!ii || gotToForcedInstance == False || VG_(strcmp)(ii->file, VG_(getClientProgramName)()) != 0)
   {
      // do not build trace entry here
      return;
   }
   
   Int instrAddr = ii->orig_addr;
   Int currInstance = ii->cur_inst - 1;

   if(ii->values == NULL)
   {
      // no defined value at this instruction instance, so skip it!
      return;
   }
   if(VG_(is_addressable)(ii->values[currInstance], sizeof(Addr)))
   {
      // the current instruction instance defines an addressable value, so assume it's an
      // address value, and skip this instruction instance!
      return;
   }
   
   sprintf(traceEntryPrefix, "%X@%d %d: ", instrAddr, ii->line, currInstance);
   sprintf(traceEntryPrefixShorter, "%X@%d: ", instrAddr, ii->line);
   
   // print the defined value (and flags if any) and the defined location
   VG_(sprintf)(traceEntrySuffix, "%d", ii->values[currInstance]);

   if(ii->flags)
   {
      VG_(sprintf)(buf, "%c%d", FLAG_DELIM, ii->flags[currInstance]);
      VG_(strcat)(traceEntrySuffix, buf);
   }
   VG_(sprintf)(buf, "!r%d $ ", ii->definedRegister);
   VG_(strcat)(traceEntrySuffix, buf);
   
   
   
   // get each used value and location
   for(j = 0; j < ii->use_port; j++) 
   {
      vs = (ii->uports)[j];
      if (!vs || !VG_(is_addressable) (vs,sizeof(val_stream)))
      {
         // the current use port is invalid, so go to the next one
         continue;
      }

      if(!VG_(is_addressable) ((vs->iis+currInstance),4) || !VG_(is_addressable) ((vs->insts+currInstance),4))
      {
         // somehow the data got corrupted, so go to the next use port
         continue;
      }
         
      otherII = (instr_info*)(vs->iis[currInstance]);
      otherInstanceNum = vs->insts[currInstance];

      if(otherII == NULL || !VG_(is_addressable)(otherII,sizeof(instr_info)))
      {
         // somehow the data got corrupted, so go to the next use port
         continue;
      }

      // print out the value of this use (only if the use is a non-address value)
      if(ii->usedRegister[j] == LOCATION_FLAG)
      {
         // print out the used flag value if it's not addressable
         if(otherII->flags && !VG_(is_addressable)(otherII->flags[otherInstanceNum], sizeof(Addr)))
         {
            VG_(sprintf)(buf, "%d", otherII->flags[otherInstanceNum]);
            VG_(strcat)(traceEntrySuffix, buf);
            VG_(sprintf)(buf, "!r%d ", ii->usedRegister[j]);
            VG_(strcat)(traceEntrySuffix, buf);
         }
      }
      else
      {
         // print out the non-flag value if it's not addressable
         if(otherII->values && !VG_(is_addressable)(otherII->values[otherInstanceNum], sizeof(Addr)))
         {
            VG_(sprintf)(buf, "%d", otherII->values[otherInstanceNum]);
            VG_(strcat)(traceEntrySuffix, buf);
            VG_(sprintf)(buf, "!r%d ", ii->usedRegister[j]);
            VG_(strcat)(traceEntrySuffix, buf);
         }
      }
   }

   // if there are any "input related" vals, those are used vals too!
   if(ii->input_related)
   {
      VG_(sprintf)(buf, "%d!INPUT ", ii->input_related[currInstance]);
      VG_(strcat)(traceEntrySuffix, buf);
   }
   
   if(providedAltMappingsToKeep == True)
   {
      // We need to check whether the current trace entry is one that was specified to
      // keep or not!
      sprintf(traceEntryToCompareToKeep, "%X %s", ii->orig_addr, traceEntrySuffix); // VG_(sprintf) won't work here for some reason...
      removeSpacesFromEndOfString(traceEntryToCompareToKeep);
      if(keepThisAltMapping(traceEntryToCompareToKeep) == False)
      {
         // skip the current trace entry
         return;
      }
   }
   
   
   /* special handling of JMP definitions (required since a 1 def is written, then a 0 def is
      subsequently written over the 1 if the conditional jump is actually *not* taken and control gets to
      the unconditional jump):
      
      1) if the current entry is a jump and the lastJumpEntry is a jump at the same instruction and instance,
         then write only the current jump entry and delete the last one
      2) else if the current entry is a jump and the lastJumpEntry is NULL, then just save the current jump as
         the lastJumpEntry
      3) else if the current entry is a jump and the lastJumpEntry is non-NULL, then write the last jump
         entry and also save the current one
      4) else if the current entry is non-jump, then write the lastJumpEntry if it exists, and clear it
   */
   if(ii->definedRegister == LOCATION_JMP)
   {
      if(lastJumpEntryPrefix[0] != '\0' && VG_(strcmp)(lastJumpEntryPrefix, traceEntryPrefix) == 0)
      {
         traceEntry[0] = '\0';
         VG_(strcat)(traceEntry, traceEntryPrefixShorter);
         VG_(strcat)(traceEntry, traceEntrySuffix);
         insertTraceEntry(traceEntry);
         
         lastJumpEntryPrefix[0] = '\0';
         lastJumpEntryFullShorter[0] = '\0';
         return;
      }
      else
      {
         if(lastJumpEntryPrefix[0] == '\0')
         {
            lastJumpEntryPrefix[0] = '\0';
            VG_(strcat)(lastJumpEntryPrefix, traceEntryPrefix);
            
            lastJumpEntryFullShorter[0] = '\0';
            VG_(strcat)(lastJumpEntryFullShorter, traceEntryPrefixShorter);
            VG_(strcat)(lastJumpEntryFullShorter, traceEntrySuffix);
            return;
         }
         else
         {
            insertTraceEntry(lastJumpEntryFullShorter);
            
            lastJumpEntryPrefix[0] = '\0';
            VG_(strcat)(lastJumpEntryPrefix, traceEntryPrefix);
            
            lastJumpEntryFullShorter[0] = '\0';
            VG_(strcat)(lastJumpEntryFullShorter, traceEntryPrefixShorter);
            VG_(strcat)(lastJumpEntryFullShorter, traceEntrySuffix);
            return;
         }
      }
   }
   else
   {
      if(lastJumpEntryPrefix[0] != '\0')
      {
         insertTraceEntry(lastJumpEntryFullShorter);
         
         lastJumpEntryPrefix[0] = '\0';
         lastJumpEntryFullShorter[0] = '\0';
      }
   }
   
   traceEntry[0] = '\0';
   VG_(strcat)(traceEntry, traceEntryPrefixShorter);
   VG_(strcat)(traceEntry, traceEntrySuffix);
   insertTraceEntry(traceEntry);
}






// if any mapping to force that is at the specified x86 instruction has currInstance *equal*
// to the instance to force, then return the forced value.  Otherwise, just return the original
// inputted value that is used here.
// Also, whenever we need to return a forced value, we MARK in the mapping structure that
// we've done the force of that value.  This is so that later, at end of execution, we can
// just do a sanity check and ensure that we processed each forced value that should have
// been processed.
//
// Note: special work needs to be done in the case of stack/heap addresses to convert the
// offset values into actual heap addresses if we're ready to force here
REGPARM(2)
UInt DJ_HELPER_get_original_or_forced_value(UInt origVal, force_helper_params *paramStruct)
{
   Int i;
   for(i = 0; i < paramStruct->numMappings; i++)
   {
      if((paramStruct->mappingsToForce)[i]->instructionAddr == paramStruct->x86_addr)
      {
         if((paramStruct->mappingsToForce)[i]->currInstance == 
            (paramStruct->mappingsToForce)[i]->instanceNum)
         {
            // need to return the *forced* value here!
            if(paramStruct->valueLocation < 0)
            {
               // it's the defined value we want to return
               (paramStruct->mappingsToForce)[i]->definedWasForced = True;
               if((paramStruct->mappingsToForce)[i]->definedAddrType == NOT_ADDR)
               {
                  return (paramStruct->mappingsToForce)[i]->definedVal;
               }
               else if((paramStruct->mappingsToForce)[i]->definedAddrType == STACK_ADDR)
               {
                  // search through the current stack allocations and find the appropriate function
                  // name and function instance num.  Then compute the actual address as baseAddress+offset
                  UInt actualAddress = 0;
                  stackNode *curr = stack;
                  while(curr != NULL)
                  {
                     if((VG_(strcmp)(curr->func, (paramStruct->mappingsToForce)[i]->funcName) == 0) &&
                        (curr->instNum == (paramStruct->mappingsToForce)[i]->funcInst))
                     {
                        actualAddress = (UInt)(curr->baseAddr) - (paramStruct->mappingsToForce)[i]->definedVal;
                        break;
                     }
                     curr = curr->next;
                  }
                  if(curr == NULL)
				  {
				     VG_(printf)("Error: could not find appropriate stack frame to compute the actual address");
				     VG_(exit)(0);
				  }
				  return actualAddress;
               }
               else if((paramStruct->mappingsToForce)[i]->definedAddrType == HEAP_ADDR)
               {
                  // search through the current heap allocations and find the appropriate heap instruction
                  // and chunk num.  Then compute the actual address as startingAddress+offset
                  UInt actualAddress = 0;
                  heapAddrNode *curr = heapAddrList;
                  while(curr != NULL)
                  {
                     if((curr->instr == (paramStruct->mappingsToForce)[i]->heapInstr) &&
                        (curr->chunkNum == (paramStruct->mappingsToForce)[i]->chunkNum))
                     {
                        actualAddress = (UInt)(curr->startAddr) + (paramStruct->mappingsToForce)[i]->definedVal;
                        break;
                     }
                     curr = curr->next;
                  }
                  if(curr == NULL)
				  {
				     VG_(printf)("Error: could not find appropriate heap chunk to compute the actual address");
				     VG_(exit)(0);
				  }
				  return actualAddress;
               }
            }
            else
            {
               // it's one of the used values we want to return
               ((paramStruct->mappingsToForce)[i]->usedWasForced)[paramStruct->valueLocation] = True;
               if((paramStruct->mappingsToForce)[i]->usedAddrType[paramStruct->valueLocation] == NOT_ADDR)
               {
                  return ((paramStruct->mappingsToForce)[i]->usedVals)[paramStruct->valueLocation];
               }
               else if((paramStruct->mappingsToForce)[i]->usedAddrType[paramStruct->valueLocation] == STACK_ADDR)
               {
                  // search through the current stack allocations and find the appropriate function
                  // name and function instance num.  Then compute the actual address as baseAddress+offset
                  UInt actualAddress = 0;
                  stackNode *curr = stack;
                  while(curr != NULL)
                  {
                     if((VG_(strcmp)(curr->func, (paramStruct->mappingsToForce)[i]->funcNames[paramStruct->valueLocation]) == 0) &&
                        (curr->instNum == (paramStruct->mappingsToForce)[i]->funcInsts[paramStruct->valueLocation]))
                     {
                        actualAddress = (UInt)(curr->baseAddr) - (paramStruct->mappingsToForce)[i]->usedVals[paramStruct->valueLocation];
                        break;
                     }
                     curr = curr->next;
                  }
                  if(curr == NULL)
				  {
				     VG_(printf)("Error: could not find appropriate heap chunk to compute the actual address 2");
				     VG_(exit)(0);
				  }
				  return actualAddress;
               }
               else if((paramStruct->mappingsToForce)[i]->usedAddrType[paramStruct->valueLocation] == HEAP_ADDR)
               {
                  // search through the current heap allocations and find the appropriate heap instruction
                  // and chunk num.  Then compute the actual address as startingAddress+offset
                  UInt actualAddress = 0;
                  heapAddrNode *curr = heapAddrList;
                  while(curr != NULL)
                  {
                     if((curr->instr == (paramStruct->mappingsToForce)[i]->heapInstrs[paramStruct->valueLocation]) &&
                        (curr->chunkNum == (paramStruct->mappingsToForce)[i]->chunkNums[paramStruct->valueLocation]))
                     {
                        actualAddress = (UInt)(curr->startAddr) + (paramStruct->mappingsToForce)[i]->usedVals[paramStruct->valueLocation];
                        break;
                     }
                     curr = curr->next;
                  }
                  if(curr == NULL)
				  {
				     VG_(printf)("Error: could not find appropriate heap chunk to compute the actual address 2");
				     VG_(exit)(0);
				  }
				  return actualAddress;
               }
            }
         }
      }
   }

   // if here, we just need to return the *original* value that was inputted to this function
   return origVal;
}

// if any mapping to force that is at the specified x86 instruction has currInstance *equal*
// to the instance to force, then return the forced flag values.  Otherwise, just return the original
// inputted flag values that are used here.
// Also, check if the defined value at the forced mapping is of type LOCATION_FLAG.  If so, MARK
// the forced, defined flag values as having been forced!
REGPARM(2)
UInt DJ_HELPER_get_original_or_forced_flags(UInt origFlagVals, force_helper_params *paramStruct)
{
   Int i;
   for(i = 0; i < paramStruct->numMappings; i++)
   {
      if((paramStruct->mappingsToForce)[i]->instructionAddr == paramStruct->x86_addr)
      {
         if((paramStruct->mappingsToForce)[i]->currInstance == 
            (paramStruct->mappingsToForce)[i]->instanceNum)
         {
            // need to return the *forced* flag values here!
            if(paramStruct->valueLocation < 0)
            {
               // force the DEFINED flag values
               if((paramStruct->mappingsToForce)[i]->definedReg == LOCATION_FLAG)
               {
                  (paramStruct->mappingsToForce)[i]->definedWasForced = True;
               }
            
               return (paramStruct->mappingsToForce)[i]->definedFlags;
            }
            else
            {
               // force the USED flag values
               ((paramStruct->mappingsToForce)[i]->usedWasForced)[paramStruct->valueLocation] = True;
               return ((paramStruct->mappingsToForce)[i]->usedVals)[paramStruct->valueLocation];
            }
         }
      }
   }
   
   // if here, we just need to return the *original* flag values that were inputted to this function
   return origFlagVals;
}

// This function has a similar purpose to the above function DJ_HELPER_get_original_or_forced_value,
// but here, this function returns the appropriate ADDRESS to jump to (instead of returning a "value"
// to be defined or used)
REGPARM(2)
UInt DJ_HELPER_get_jump_addr(UInt flagValues, force_helper_params *paramStruct)
{
   Int i;

   Bool isCondTrue;
   
   // determine whether the conditional jump would originally be taken or not
   switch(paramStruct->condJumpType)
   {
      case CondAlways: /* always true */
      {
         // jump always
         isCondTrue = True;
         break;
      }
      case CondO: /* overflow           */
      {
         // jump if O flag is set
         isCondTrue =  (flagValues & EFlagO)? True : False;
         break;
      }
      case CondNO: /* no overflow        */
      {
         // jump if O flag is not set
         isCondTrue =  (flagValues & EFlagO)? False : True;
         break;
      }
      case CondB: /* below              */
      {
         // jump if C flag is set
         isCondTrue =  (flagValues & EFlagC)? True : False;
         break;
      }
      case CondNB: /* not below          */
      {
         // jump if C flag is not set
         isCondTrue =  (flagValues & EFlagC)? False : True;
         break;
      }
      case CondZ: /* zero               */
      {
         // jump if Z flag is set
         isCondTrue =  (flagValues & EFlagZ)? True : False;
         break;
      }
      case CondNZ: /* not zero           */
      {
         // jump if Z flag is not set
         isCondTrue =  (flagValues & EFlagZ)? False : True;
         break;
      }
      case CondBE: /* below or equal     */
      {
         // jump if C flag is set OR Z flag is set
         isCondTrue =  ((flagValues & EFlagC) || (flagValues & EFlagZ))? True : False;
         break;
      }
      case CondNBE: /* not below or equal */
      {
         // jump if C flag is not set AND Z flag is not set
         isCondTrue =  ((flagValues & EFlagC) || (flagValues & EFlagZ))? False : True;
         break;
      }
      case CondS: /* negative           */
      {
         // jump if S flag is set
         isCondTrue =  (flagValues & EFlagS)? True : False;
         break;
      }
      case CondNS: /* not negative       */
      {
         // jump if S flag is not set
         isCondTrue =  (flagValues & EFlagS)? False : True;
         break;
      }
      case CondP: /* parity even        */
      {
         // jump if P flag is set
         isCondTrue =  (flagValues & EFlagP)? True : False;
         break;
      }
      case CondNP: /* not parity even    */
      {
         // jump if P flag is not set
         isCondTrue =  (flagValues & EFlagP)? False : True;
         break;
      }
      case CondL: /* jump less          */
      {
         // jump if S and O flags are NOT THE SAME
         if((flagValues & EFlagS) && !(flagValues & EFlagO))
         {
            isCondTrue =  True;
         }
         else if(!(flagValues & EFlagS) && (flagValues & EFlagO))
         {
            isCondTrue =  True;
         }
         else
         {
            isCondTrue =  False;
         }
         break;
      }
      case CondNL: /* not less           */
      {
         // jump if S and O flags are THE SAME
         if((flagValues & EFlagS) && (flagValues & EFlagO))
         {
            isCondTrue =  True;
         }
         else if(!(flagValues & EFlagS) && !(flagValues & EFlagO))
         {
            isCondTrue =  True;
         }
         else
         {
            isCondTrue =  False;
         }
         break;
      }
      case CondLE: /* less or equal      */
      {
         // jump if Z flag is set, OR if S and O flags are NOT THE SAME
         if((flagValues & EFlagZ))
         {
            isCondTrue =  True;
         }
         else if((flagValues & EFlagS) && !(flagValues & EFlagO))
         {
            isCondTrue =  True;
         }
         else if(!(flagValues & EFlagS) && (flagValues & EFlagO))
         {
            isCondTrue =  True;
         }
         else
         {
            isCondTrue =  False;
         }
         break;
      }
      case CondNLE: /* not less or equal  */
      {
         // jump if Z flag is not set, AND if S and O flags are THE SAME
         if(!(flagValues & EFlagZ) && (flagValues & EFlagS) && (flagValues & EFlagO))
         {
            isCondTrue =  True;
         }
         else if(!(flagValues & EFlagZ) && !(flagValues & EFlagS) && !(flagValues & EFlagO))
         {
            isCondTrue =  True;
         }
         else
         {
            isCondTrue =  False;
         }
         break;
      }
      default:
      {
         VG_(printf)("Error: unknown conditional jump type %d\n", paramStruct->condJumpType);
         VG_(exit)(0);
      }
   }
   
   // scan the mappings to force
   for(i = 0; i < paramStruct->numMappings; i++)
   {
      if((paramStruct->mappingsToForce)[i]->instructionAddr == paramStruct->x86_addr)
      {
         if((paramStruct->mappingsToForce)[i]->currInstance == 
            (paramStruct->mappingsToForce)[i]->instanceNum)
         {
            // need to return the forced jump address value here!
            if((paramStruct->mappingsToForce)[i]->definedVal == 0)
            {
               // want to force the UNCONDITIONAL jump to be taken
               (paramStruct->mappingsToForce)[i]->definedWasForced = True;
               return paramStruct->uncondJumpAddr;
            }
            else if((paramStruct->mappingsToForce)[i]->definedVal == 1)
            {
               // want the CONDITIONAL jump to be taken
               (paramStruct->mappingsToForce)[i]->definedWasForced = True;
               return paramStruct->condJumpAddr;
            }
            else
            {
               VG_(printf)("Error: trying to force jump addr, but jump result is neither 1 nor 0!\n");
               VG_(exit)(0);
            }
            
         }
      }
   }
   
   // if here, we just need to return the *original* jump address value that would have been taken
   if(isCondTrue == True)
   {
      // the conditional jump WOULD have been taken, so make sure we jump there
      return paramStruct->condJumpAddr;
   }
   else
   {
      // the conditional jump would NOT have been taken, so make sure we jump to the
      // unconditional-jump destination
      return paramStruct->uncondJumpAddr;
   }
}

void XZ_HELPER_debug_terminate() 
{
    VG_(exit)(-1);
}
REGPARM(3)
void XZ_HELPER_debug_print_reg(Addr addr, Int reg_num, Int reg_content)
{
    VG_(printf)("BREAK POINT @ %x , reg %d has the content of %d(%x)\n",
           addr, reg_num, reg_content,reg_content);
}

REGPARM(2)
void XZ_HELPER_debug_get(Int idx, Int arch_reg) 
{
    instr_info * ii=sh_regs[arch_reg].ii;
    Int inst=sh_regs[arch_reg].inst;
    if (ii) {
        VG_(printf) ("%d GET %d = (%x,%s,%s,%d -- %d)\n",idx,arch_reg,ii->orig_addr,
           ii->file, ii->fn, ii->line, inst);
    } else {
	VG_(printf) ("%d GET %d = no definition\n", idx, arch_reg);
    }
}

REGPARM(3)
void XZ_HELPER_debug_put(Int idx, instr_info * ii, Int inst) 
{
    if (ii) {
        VG_(printf) ("%d PUT (%x,%s,%s,%d -- %d) \n",idx,ii->orig_addr,
           ii->file, ii->fn, ii->line, inst);
    } else {
	VG_(printf) ("%d PUT no definition\n", idx);
    }
}

REGPARM(1)
void XZ_HELPER_debug(Int idx) 
{
    VG_(printf) ("%d\n",idx);
}

REGPARM(2)
void XZ_HELPER_init_lvs_new (UChar * old_esp, fun_entry * fe)
{
    UChar * lvs;
    Int i;
    lvs=old_esp;
    //VG_(printf) ("ESP=%x\n",old_esp);
    //*(UInt*)(lvs-4)=0;
    lvs+=LAST_PREDICATE+CD_TIMESTAMP_OFFSET-4;
    
    //lvs=esp+(PER_CD_SPACE-CD_TIMESTAMP_OFFSET);
    //VG_(printf)("Initialize %x-> +%d\n",lvs, fe->alloc_lv);
    for (i=0;i<fe->alloc_lv;i++) {
       //VG_(printf)("%s: set %x to 0\n",fe->fn->fn,lvs);
       *(UInt*)lvs=0;
       lvs+=PER_CD_SPACE;
    }
    //VG_(printf) ("Initialize done\n");
}

REGPARM(2)
void XZ_HELPER_init_lvs (UChar * ebp, fun_entry * fe)
{
    UChar * lvs;
    Int i;
    lvs=ebp-fe->orig_sp_offset;
    *(UInt*)(lvs-4)=0;
    lvs-=LAST_PREDICATE+CD_TIMESTAMP_OFFSET;
    
    //lvs=esp+(PER_CD_SPACE-CD_TIMESTAMP_OFFSET);
    //VG_(printf)("Initialize %x-> +%d\n",lvs, fe->alloc_lv);
    for (i=0;i<fe->alloc_lv-2;i++) {
       //VG_(printf)("%s: set %x to 0\n",fe->fn->fn,lvs);
       *(UInt*)lvs=0;
       lvs-=PER_CD_SPACE;
    }
    //VG_(printf) ("Initialize done\n");
}
#ifdef TRACK_ARGV
REGPARM(2)
void XZ_HELPER_track_argv(Int argc, Char ** argv)
{
    Int i,j;
    Char * arg;
    //VG_(printf)("ARGC=%d\n",argc);
    for (i=1;i<argc;i++) {
       arg=argv[i];
       //VG_(printf) ("ARGV[%d]=%s\n",i, arg);
       for (j=0;j<VG_(strlen)(arg);j++) {
	  set_ii_vbytes4_ALIGNED((Addr)(arg+j),INPUT_RELEVANT);
          set_inst_vbytes4_ALIGNED((Addr)(arg+j),arg[j]);
       }//j
    }//i
}
#endif

#ifdef INTER_CD
//create dummy data dep which is acting as interprocedural CD
REGPARM(2)
void XZ_HELPER_create_dummy_CD(instr_info * ii,UInt * esp)
{
     set_ii_vbytes4_ALIGNED(esp,ii);
     set_inst_vbytes4_ALIGNED(esp,ii->cur_inst);
     VG_(printf) ("CALL SITE define %x as (%d,%d)\n",esp, ii->id, ii->cur_inst);
}

/*
REGPARM(2)
void XZ_HELPER_create_dummy_CD(instr_info * ii, Int uport)
{

    insert_dependence(&ii->uports[uport],ii->cur_inst, sh_regs[R_ESP].ii,sh_regs[R_ESP].inst);
    sh_regs[R_ESP].ii=ii;
    sh_regs[R_ESP].inst=ii->cur_inst;

    
}
*/
#endif
//setup the control dependence for ii
REGPARM(2)
void XZ_HELPER_setup_CD_new (instr_info * ii, UChar * ebp)
{
        Int i;
        UInt max_ts=0;
        UInt ts;
        UChar * lvs;
        instr_info * r_ii;
        Int r_inst;
        Int lv_idx;
        Int start_printing=0;
        lvs=ebp;
        UChar * old_ebp;
	
        sk_assert(ii->bb!=NULL);
        instr_info * bb=ii->bb;
        //VG_(printf) ("TRY TO SET UP CD for %x, cd_cnt=%d\n",bb->orig_addr, bb->cd_cnt); 
#ifdef INTER_CD
	if (!bb->cd_cnt) {//no CD, which means it is a inter CD
	    if (ii->fe->cd_available) {
		old_ebp=ebp+ii->fe->alloc_lv*PER_CD_SPACE+LAST_PREDICATE;
		r_ii=get_ii_vbytes4_ALIGNED(old_ebp+4);
                r_inst=get_inst_vbytes4_ALIGNED(old_ebp+4);
             } else {
		r_ii=get_ii_vbytes4_ALIGNED(ebp+4);
                r_inst=get_inst_vbytes4_ALIGNED(ebp+4);
		old_ebp=ebp;
	     }

             VG_(printf) ("INTER CD get define at %x as (%x,%d)\n",old_ebp, r_ii, r_inst);
	     if (r_ii==0xFFFFFFFF) return;
             VG_(printf) ("\tINTER CD r_ii=%d)\n", r_ii->id);
             insert_dependence(&ii->uports[0],ii->cur_inst, r_ii,r_inst);
	    return;
        }
#endif
        for (i=0;i<bb->cd_cnt;i++) {
                instr_info * cd=bb->cds[i];
                //cd->lv_idx==-1 means that no local variable has been assigned to it.
                //if (cd->lv_idx<0) continue;
                ts=*((UInt*)(lvs+PER_CD_SPACE*cd->lv_idx+CD_TIMESTAMP_OFFSET-4));
                //if (start_printing)
                 
		    /*VG_(printf) ("%d(%x):ebp=%x lv_idx=%d(%d) ts(%x)=%d, r_ii=%x, r_inst=%x\n", i,cd->orig_addr, lvs, cd->lv_idx,ii->fe->alloc_lv, 
                        (UInt*)(lvs+PER_CD_SPACE*cd->lv_idx+CD_TIMESTAMP_OFFSET-4), ts,
                        ((UInt*)(lvs+PER_CD_SPACE*cd->lv_idx+CD_II_OFFSET-4)),
                        ((UInt*)(lvs+PER_CD_SPACE*cd->lv_idx+CD_INST_OFFSET-4)));                
                     */
                if (ts>max_ts) {
                        max_ts=ts;
                        lv_idx=cd->lv_idx;
                        r_ii=(instr_info*) *((UInt*)(lvs+PER_CD_SPACE*cd->lv_idx+CD_II_OFFSET-4));                
                        r_inst=*((UInt*)(lvs+PER_CD_SPACE*cd->lv_idx+CD_INST_OFFSET-4));              
                }
        }


        if (max_ts==0) {
                return ;
        }
        sk_assert(r_ii!=NULL);

        //sk_assert(r_ii->pred_ii!=NULL);
        //VG_(printf) ("CD: on %x (%s, %s, %d)\n",r_ii->orig_addr, r_ii->file, r_ii->fn, r_ii->line);
        //insert_dependence(&ii->uports[0],ii->cur_inst, r_ii->pred_ii,r_inst);

        insert_dependence(&ii->uports[0],ii->cur_inst, r_ii,r_inst);
}


//setup the control dependence for ii
REGPARM(2)
void XZ_HELPER_setup_CD (instr_info * ii, UChar * ebp)
{
        Int i;
        UInt max_ts=0;
        UInt ts;
        UChar * lvs;
        instr_info * r_ii;
        Int r_inst;
        Int lv_idx;
        Int start_printing=0;
        lvs=ebp - ii->fe->orig_sp_offset-LAST_PREDICATE;
	
        sk_assert(ii->bb!=NULL);
        instr_info * bb=ii->bb;
        for (i=0;i<bb->cd_cnt;i++) {
                instr_info * cd=bb->cds[i];
                //cd->lv_idx==-1 means that no local variable has been assigned to it.
                //if (cd->lv_idx<0) continue;
                ts=*((UInt*)(lvs-PER_CD_SPACE*cd->lv_idx-CD_TIMESTAMP_OFFSET));
                //if (start_printing)
		    /*VG_(printf) ("%d: lv_idx=%d(%d) ts(%x)=%d, r_ii=%x, r_inst=%d\n", i, cd->lv_idx,ii->fe->alloc_lv, 
                        (UInt*)(lvs-PER_CD_SPACE*cd->lv_idx-CD_TIMESTAMP_OFFSET), ts,
                        *((UInt*)(lvs-PER_CD_SPACE*cd->lv_idx-CD_II_OFFSET)),
                        *((UInt*)(lvs-PER_CD_SPACE*cd->lv_idx-CD_INST_OFFSET)));                
                      */
                if (ts>max_ts) {
                        max_ts=ts;
                        lv_idx=cd->lv_idx;
                        r_ii=(instr_info*) *((UInt*)(lvs-PER_CD_SPACE*cd->lv_idx-CD_II_OFFSET));                
                        r_inst=*((UInt*)(lvs-PER_CD_SPACE*cd->lv_idx-CD_INST_OFFSET));                }
        }

        if (start_printing) {
             //VG_(printf) ("%s,max_ts=%d, EBP=%x, CD BDD[%x]=%x, be->orig_sp_offset=%d, be->addr=%x, be->lv_idx=%d\n",be->fe->fn->fn,max_ts,(UInt)ebp,PER_CD_SPACE*lv_idx+CD_TIMESTAMP_OFFSET
             //     +be->fe->orig_sp_offset+LAST_PREDICATE,r,be->fe->orig_sp_offset, be->orig_addr, lv_idx);
        }

        if (max_ts==0) {
                return ;
        }
        sk_assert(r_ii!=NULL);
        //sk_assert(r_ii->pred_ii!=NULL);
        //insert_dependence(&ii->uports[0],ii->cur_inst, r_ii->pred_ii,r_inst);
        insert_dependence(&ii->uports[0],ii->cur_inst, r_ii,r_inst);
}

#ifdef VALUE_WANTED

// DENNIS created this function to record the current defined flag values in the ii structure
REGPARM(2)
void DJ_set_flags_defined(instr_info * ii, UInt flagSet)
{
    insert_flag_value(ii, flagSet);
}

REGPARM(3)
void XZ_HELPER_trace_value1(instr_info * ii, UInt value)
{
    UInt v=value & 0xff;
    //VG_(printf)("insert (1)%x @ <%x,%d>\n",v, ii->orig_addr, ii->cur_inst);
    
    insert_value(ii,v);
    //insert_value_base(ii,value & 0xff,base);
    //VG_(printf)("insert done\n");
}

REGPARM(3)
void XZ_HELPER_trace_value2(instr_info * ii, UInt value)
{
    UInt v=value & 0xffff;
    //VG_(printf)("insert (2)%x @ <%x,%d>\n",v, ii->orig_addr, ii->cur_inst);
    
    insert_value(ii,v);
     
}

REGPARM(3)
void XZ_HELPER_trace_value4(instr_info * ii, UInt value)
{
    //VG_(printf)("insert %x @ <%x,%d>\n",value, ii->orig_addr, ii->cur_inst);
    
    insert_value(ii,value);
    //insert_value_base(ii,value,base);
    //VG_(printf)("insert done\n");
}

/*

REGPARM(2)
void XZ_HELPER_trace_value(instr_info * ii, UInt value)
{
    //VG_(printf)("insert %x @ <%x,%d>\n",value, ii->orig_addr, ii->cur_inst);
    
    insert_value(ii,value);
    //VG_(printf)("insert done\n");
}
*/
#endif 

#ifdef TIMESTAMPED
REGPARM(1)
void XZ_HELPER_trace_timestamp(instr_info * ii)
{
    //VG_(printf)("insert %x @ <%x,%d>\n",timestamp, ii->orig_addr, ii->cur_inst);
    //VG_(printf)("XXX Trace ts=%d for %x\n",timestamp,ii->orig_addr); 
    insert_timestamp(ii,timestamp++);
    //VG_(printf)("insert done\n");
}
REGPARM(2)
void XZ_HELPER_trace_control_flow(instr_info * bb, Addr branch_pc)
{
    insert_control_flow(bb, branch_pc);
}
#endif 

//port 0 is CD, port 1 is addr, port 2 is mem
REGPARM(3)
void XZ_HELPER_pred_dep (instr_info * ii, Int uport, instr_info * def_ii)
{
     if (!def_ii) return;
     insert_dependence(&ii->uports[uport], ii->cur_inst, def_ii, def_ii->cur_inst-1);
}


//port 0 is CD, port 1 is addr, port 2 is mem
REGPARM(3)
void XZ_HELPER_reg_dep_port1 (instr_info * ii, instr_info * def_ii, Int def_inst)
{
     if (!def_ii) return;
     insert_dependence(&ii->uports[1], ii->cur_inst, def_ii, def_inst);
}

REGPARM(3)
void XZ_HELPER_reg_dep_port2 (instr_info * ii, instr_info * def_ii, Int def_inst)
{
     if (!def_ii) return;
     insert_dependence(&ii->uports[2], ii->cur_inst, def_ii, def_inst);
}

REGPARM(3)
void XZ_HELPER_reg_dep_port3 (instr_info * ii, instr_info * def_ii, Int def_inst)
{
     if (!def_ii) return;
     insert_dependence(&ii->uports[3], ii->cur_inst, def_ii, def_inst);
}

REGPARM(3)
void XZ_HELPER_reg_dep_port4 (instr_info * ii, instr_info * def_ii, Int def_inst)
{
     if (!def_ii) return;
     insert_dependence(&ii->uports[4], ii->cur_inst, def_ii, def_inst);
}

REGPARM(3)
void XZ_HELPER_reg_dep_port5 (instr_info * ii, instr_info * def_ii, Int def_inst)
{
     if (!def_ii) return;
     insert_dependence(&ii->uports[5], ii->cur_inst, def_ii, def_inst);
}

REGPARM(3)
void XZ_HELPER_reg_dep_port6 (instr_info * ii, instr_info * def_ii, Int def_inst)
{
     if (!def_ii) return;
     insert_dependence(&ii->uports[6], ii->cur_inst, def_ii, def_inst);
}


REGPARM(3)
void XZ_HELPER_load_mem_dep (instr_info * ii, Int uport, Addr a)
{
     instr_info * mem_def_ii;
     Int mem_def_inst;
     
     //DEBUG
//#define DEBUG     
#ifdef DEBUG
     VG_(printf) ("LOAD_MEM_DEP START ii=%d(%x,%s,%s,%d), inst=%d, addr=%x\n",ii->id, ii->orig_addr, ii->file, ii->fn, ii->line, ii->cur_inst,a);
#endif
     mem_def_ii=get_ii_vbytes4_ALIGNED(a);
     mem_def_inst=get_inst_vbytes4_ALIGNED(a);
     
     if (!mem_def_ii || (UInt)mem_def_ii==0xffffffff) {
         //VG_(printf) ("LOAD_MEM_DEP End\n");
         return;
     }
#ifdef TRACK_INPUT
     if ((UInt)mem_def_ii==INPUT_RELEVANT) {
//#ifdef DEBUG
     	 //VG_(printf) ("INPUT RELATED ii=%d(%x,%s,%s,%d), inst=%d, value=%x '%c' addr=%x\n",ii->id, ii->orig_addr, ii->file, ii->fn, ii->line, ii->cur_inst,mem_def_inst,mem_def_inst,a);
//#endif
         set_input_relevance(ii,mem_def_inst);
         return;
     }
#endif
     //DEBUG
#ifdef DEBUG
     VG_(printf) ("\tdef_ii=<%s,%s,%d>, inst=%d\n", mem_def_ii->file, mem_def_ii->fn, mem_def_ii->line, mem_def_inst);
#endif

     insert_dependence(&ii->uports[uport], ii->cur_inst, mem_def_ii, mem_def_inst);
     //VG_(printf) ("LOAD_MEM_DEP End\n");
}

REGPARM(3)
void XZ_HELPER_store_mem_dep(instr_info * ii,Int size, Addr a)
{
#ifdef DEBUG
     VG_(printf) ("store %x ii=%d<%s,%s,%d>, inst=%d, a=%x\n", a, ii->id,ii->file, ii->fn, ii->line, ii->cur_inst,a);
#endif
#ifndef BYTE_GRANUITY
     set_ii_vbytes4_ALIGNED(a,ii);
     set_inst_vbytes4_ALIGNED(a,ii->cur_inst);
#else

     switch (size) {
	case 1:
     	 set_ii_vbytes4_ALIGNED(a,ii);
         set_inst_vbytes4_ALIGNED(a,ii->cur_inst);
	 break;
       case 2:
         set_ii_vbytes4_ALIGNED(a,ii);
         set_inst_vbytes4_ALIGNED(a,ii->cur_inst);
         set_ii_vbytes4_ALIGNED(a+1,ii);
         set_inst_vbytes4_ALIGNED(a+1,ii->cur_inst);
	 break;
       case 4:
         set_ii_vbytes4_ALIGNED(a,ii);
         set_inst_vbytes4_ALIGNED(a,ii->cur_inst);
         set_ii_vbytes4_ALIGNED(a+1,ii);
         set_inst_vbytes4_ALIGNED(a+1,ii->cur_inst);
         set_ii_vbytes4_ALIGNED(a+2,ii);
         set_inst_vbytes4_ALIGNED(a+2,ii->cur_inst);
         set_ii_vbytes4_ALIGNED(a+3,ii);
         set_inst_vbytes4_ALIGNED(a+3,ii->cur_inst);
         break;
      }
#endif

}

REGPARM(1)
Int XZ_HELPER_get_timestamp(UInt novalue)
{
#ifndef TIMESTAMPED
     return timestamp;
#else
     return timestamp++;
#endif
}

REGPARM(1)
void XZ_HELPER_debug_EBP_set_value(UInt value,Addr bb)
{
    VG_(printf) ("+EBP is set to %x at %x\n", value,bb);
}
REGPARM(1)
void XZ_HELPER_debug_EBP_get_value(UInt value, Addr bb)
{
    VG_(printf) ("get +EBP=%x at %x\n", value,bb);
}

REGPARM(1)
void XZ_HELPER_debug_BB(Addr a)
{
    VG_(printf) ("+BB+ %x\n", a);
}
