#ifndef __LK_HELPERS_H
#define __LK_HELPERS_H

#include "vg_skin.h"
#include "utility.h"
#define PER_CD_SPACE 12
#define CD_II_OFFSET 4 
#define CD_INST_OFFSET 8
#define CD_TIMESTAMP_OFFSET 12
#define LAST_PREDICATE 0 
//#define LAST_PREDICATE 12 
#define LV_NOT_ASSIGNED -1

extern void write_trace_optimized(Char *file);

REGPARM(3)
void DJ_record_stmt_info(Char *file, Char *function, Int line);

REGPARM(3)
void DJ_transfer_mark_arch_temp_to_temp(UInt archRegSource1, UInt tempRegSource2, UInt tempRegDest);

REGPARM(3)
void DJ_transfer_mark_temp_temp_to_temp(UInt tempRegSource1, UInt tempRegSource2, UInt tempRegDest);

REGPARM(2)
void DJ_transfer_mark_temp_to_temp(UInt tempRegSource, UInt tempRegDest);

REGPARM(2)
void DJ_transfer_mark_temp_to_arch(UInt tempReg, UInt archReg);

REGPARM(2)
void DJ_transfer_mark_arch_to_temp(UInt archReg, UInt tempReg);

REGPARM(2)
void DJ_transfer_mark_temp_to_archS(UInt tempReg, UInt archRegS);

REGPARM(2)
void DJ_transfer_mark_archS_to_temp(UInt archRegS, UInt tempReg);

REGPARM(1)
void DJ_mark_not_suppressed_temp(UInt tempReg);

REGPARM(2)
void DJ_set_dest_reg_for_load(UInt tempReg, Addr currX86Addr);

REGPARM(2)
void DJ_set_flag_for_store_if_suppressed(UInt tempRegSource, UInt tempRegDest);

REGPARM(2)
UInt DJ_handle_load_to_possibly_suppress(UInt sourceTempReg, Addr sourceAddr);

REGPARM(2)
UInt DJ_handle_initial_suppression_point(Addr currX86Addr, Addr addressStoredTo);

REGPARM(1)
void DJ_print_value(UInt value);

REGPARM(2)
void DJ_debug_trace(Addr currX86Addr, UInt opcode);

REGPARM(1)
Int XZ_HELPER_get_inst (instr_info * ii);

REGPARM(1)
void XZ_HELPER_increment_inst (x86InstrStruct * node);

REGPARM(3)
void DJ_HELPER_increment_force_inst(Addr x86_addr, mapping_force *mappings [], Int numMappings);

REGPARM(3)
void DJ_HELPER_set_flag_at_forced_inst(Addr x86_addr, mapping_force *mappings [], Int numMappings);

REGPARM(2)
UInt DJ_HELPER_get_original_or_forced_value(UInt origVal, force_helper_params *paramStruct);

REGPARM(2)
UInt DJ_HELPER_get_original_or_forced_flags(UInt origFlagVals, force_helper_params *paramStruct);

REGPARM(2)
UInt DJ_HELPER_get_jump_addr(UInt flagValues, force_helper_params *paramStruct);

REGPARM(2)
void DJ_set_flags_defined(instr_info * ii, UInt flagSet);

REGPARM(1)
void DJ_update_last_instr_main_file(instr_info * ii);

REGPARM(1)
void DJ_processTraceEntry(instr_info *ii);

REGPARM(1)
void DJ_HELPER_record_stmt(Int stmt);

REGPARM(1)
void DJ_got_func_ret(fnCC *functionObject);

REGPARM(2)
void DJ_got_func_entry(fnCC *functionObject, UInt baseAddr);

REGPARM(0)
void DJ_junk();

REGPARM(1)
void XZ_HELPER_debug (Int);

REGPARM(2)
void XZ_HELPER_debug_get (Int,Int);

REGPARM(3)
void XZ_HELPER_debug_put (Int,instr_info *, Int);

REGPARM(3)
void XZ_HELPER_debug_print_reg (Addr, Int, Int);

void XZ_HELPER_debug_terminate ();

REGPARM(1)
void XZ_HELPER_debug_BB (Addr);

REGPARM(3)
void XZ_HELPER_debug_store_value(Addr, UInt, Addr);

REGPARM(3)
void XZ_HELPER_debug_load_value (Addr, Addr, UInt);

REGPARM(1)
void XZ_HELPER_debug_EBP_get_value(UInt,Addr bb);

REGPARM(1)
void XZ_HELPER_debug_EBP_set_value(UInt, Addr bb);

REGPARM(2)
void XZ_HELPER_init_lvs_new (UChar * ebp, fun_entry * fe);

REGPARM(2)
void XZ_HELPER_track_argv (Int argc, Char ** argv);

REGPARM(2)
void XZ_HELPER_setup_CD_new (instr_info * ii, UChar * ebp);

REGPARM(2)
void XZ_HELPER_init_lvs (UChar * ebp, fun_entry * fe);

REGPARM(2)
void XZ_HELPER_setup_CD (instr_info * ii, UChar * ebp);

REGPARM(1)
void XZ_HELPER_trace_timestamp(instr_info * ii);

REGPARM(2)
void XZ_HELPER_trace_control_flow(instr_info * bb, Addr pc);

REGPARM(3)
void XZ_HELPER_trace_value1(instr_info * ii, UInt value);

REGPARM(3)
void XZ_HELPER_trace_value2(instr_info * ii, UInt value);

REGPARM(3)
void XZ_HELPER_trace_value4(instr_info * ii, UInt value);

REGPARM(3)
void XZ_HELPER_pred_dep (instr_info * ii, Int uport, instr_info * def_ii);

REGPARM(3)
void XZ_HELPER_reg_dep_port1 (instr_info * ii, instr_info * def_ii, Int def_inst);
REGPARM(3)
void XZ_HELPER_reg_dep_port2 (instr_info * ii, instr_info * def_ii, Int def_inst);
REGPARM(3)
void XZ_HELPER_reg_dep_port3 (instr_info * ii, instr_info * def_ii, Int def_inst);
REGPARM(3)
void XZ_HELPER_reg_dep_port4 (instr_info * ii, instr_info * def_ii, Int def_inst);
REGPARM(3)
void XZ_HELPER_reg_dep_port5 (instr_info * ii, instr_info * def_ii, Int def_inst);
REGPARM(3)
void XZ_HELPER_reg_dep_port6 (instr_info * ii, instr_info * def_ii, Int def_inst);

REGPARM(3)
void XZ_HELPER_load_mem_dep (instr_info * ii, Int uport, Addr a);

REGPARM(3)
void XZ_HELPER_store_mem_dep(instr_info * ii, Int size,Addr a);

REGPARM(2)
void XZ_HELPER_create_dummy_CD(instr_info * ii, UInt*);

REGPARM(1)
Int XZ_HELPER_get_timestamp(UInt novalue);

typedef struct _XZ_shadow_reg XZ_shadow_reg;
struct _XZ_shadow_reg {
  instr_info * ii;
  Int inst;
};


#endif
